﻿* Encoding: UTF-8.
***********************************************************************
** Syntaksfil for Enhet og mangfold 4. utgave, kapitlene 15 - 21.
************************************************************************.
* Alle datafilene kan lastes ned samlet fra bokas nettsted og må lagres lokalt før de kan åpnes i SPSS.
**********************************************.
* Kapittel 15.
***********.
* Datasett xy.sav må være åpnet
* Lister alle variabler for alle enheter + beskrivende statistikk.
list.
DESCRIPTIVES all.
CORRELATIONS   /VARIABLES=x y   /PRINT=TWOTAIL NOSIG   /MISSING=PAIRWISE.
* Spredmnngsdiagram figur 15.2, men ikke redigert som i figuren.
* Chart Builder. 
GGRAPH 
  /GRAPHDATASET NAME="graphdataset" VARIABLES=x y MISSING=LISTWISE REPORTMISSING=NO 
  /GRAPHSPEC SOURCE=INLINE 
  /FITLINE TOTAL=NO. 
BEGIN GPL 
  SOURCE: s=userSource(id("graphdataset")) 
  DATA: x=col(source(s), name("x"), unit.category()) 
  DATA: y=col(source(s), name("y")) 
  GUIDE: axis(dim(1), label("Utdanning")) 
  GUIDE: axis(dim(2), label("timelønn")) 
  GUIDE: text.title(label("Simple Scatter of timelønn by Utdanning")) 
  SCALE: linear(dim(2), include(0)) 
  ELEMENT: point(position(x*y)) 
END GPL.
************************************************.
* Kapittel 16
**********
** Datasett abu89.sav må være åpnet.
*** Frekvekstanell for promot.
FREQUENCIES VARIABLES=promot  /ORDER=ANALYSIS.
** Krysstabeller.
* Bare frekvenser.
CROSSTABS   /TABLES=promot BY female   /FORMAT=AVALUE TABLES
  /CELLS=COUNT    /COUNT ROUND CELL.
* Bare kolonneprosenter.
CROSSTABS
  /TABLES=promot BY female   /FORMAT=AVALUE TABLES
  /CELLS=COLUMN   /COUNT ROUND CELL.
* Bare linjeprosenter.
CROSSTABS   /TABLES=promot BY female   /FORMAT=AVALUE TABLES
  /CELLS=ROW   /COUNT ROUND CELL.
* Bare prosenter av tabelltotal.
CROSSTABS   /TABLES=promot BY female   /FORMAT=AVALUE TABLES
  /CELLS=TOTAL   /COUNT ROUND CELL.
*** Tabell 16.2.
CROSSTABS   /TABLES=promot BY female BY private
  /FORMAT=AVALUE TABLES   /STATISTICS=CHISQ PHI 
  /CELLS=COLUMN   /COUNT ROUND CELL.
*****************************************************.
* Kapittel 17
*******.
* Datasett ESS8NO_tillit.sav må være åpnet.
* Kloner de 5 indikatorene til variabler mer forståelige navn.
COMPUTE storting = trstprl.
COMPUTE rettsvesen = trstlgl.
COMPUTE politi = trstplc.
COMPUTE politikere = trstplt.
COMPUTE partier = trstprt.
DESCRIPTIVES storting rettsvesen politi politikere partier.
****** Faktoranalyse.
FACTOR
  /VARIABLES storting rettsvesen politi politikere partier
  /MISSING LISTWISE 
  /ANALYSIS storting rettsvesen politi politikere partier
  /PRINT INITIAL EXTRACTION
  /CRITERIA MINEIGEN(1) ITERATE(25)
  /EXTRACTION PC
  /ROTATION NOROTATE
  /METHOD=CORRELATION.
**** Tofaktor-løsning.
FACTOR
  /VARIABLES storting rettsvesen politi politikere partier
  /MISSING LISTWISE 
  /ANALYSIS storting rettsvesen politi politikere partier
  /PRINT INITIAL EXTRACTION ROTATION
  /FORMAT SORT
  /CRITERIA FACTORS(2) ITERATE(25)
  /EXTRACTION PC
  /CRITERIA ITERATE(25)
  /ROTATION VARIMAX
  /METHOD=CORRELATION.
* Reliabilitetsanalyse.
RELIABILITY
  /VARIABLES=storting rettsvesen politi politikere partier
  /SCALE('ALL VARIABLES') ALL
  /MODEL=ALPHA
  /STATISTICS=DESCRIPTIVE SCALE CORR
  /SUMMARY=TOTAL CORR.
*** Lage indeks som gjennomsnitt for de fem indikatorene.
compute tillit = mean.5(storting, rettsvesen, politi, politikere, partier).
DESCRIPTIVES tillit.
descriptives all.
********************************************************
* Kapittel 18.
********************.
** t-testen for to uavhengige utvalg
** Datasett abu89.sav må være åpnet.
T-TEST GROUPS=female(0 1)
  /MISSING=ANALYSIS
  /VARIABLES=time89
  /CRITERIA=CI(.95).
* T-testen for parede utvalg.
** Datasett abu89_93.sav må være åpnet.
T-TEST PAIRS=time93 WITH time89 (PAIRED)   /CRITERIA=CI(.9500)   /MISSING=ANALYSIS.
** enveis variansanalyse.
** Datasett abu89.sav må være åpnet.
ONEWAY time89 BY klasse89   /MISSING ANALYSIS.
* Mer utførlig rapportering fra ANOVA, med effektstørrelse.
UNIANOVA time89 BY klasse89
  /METHOD=SSTYPE(3)
  /INTERCEPT=INCLUDE
  /PRINT ETASQ PARAMETER
  /CRITERIA=ALPHA(.05)
  /DESIGN=klasse89.
*******************************************************************.
* Kapittel 19.
***********.
* Datasett abu89.sav må være åpnet.
* Tabell 19.3.
DESCRIPTIVES time89 ed age female.
* Figur 19.9.
GRAPH   /HISTOGRAM(NORMAL)=time89.
***************
* Utskift for  Modell 1, s 419.
REGRESSION
  /MISSING LISTWISE
  /STATISTICS COEFF OUTS R ANOVA
  /CRITERIA=PIN(.05) POUT(.10)
  /NOORIGIN 
  /DEPENDENT time89
  /METHOD=ENTER ed.
**************.
* Tabell 19.4 Modell 1&2 
******.
REGRESSION
  /MISSING LISTWISE
  /STATISTICS COEFF OUTS R ANOVA CHANGE
  /CRITERIA=PIN(.05) POUT(.10)
  /NOORIGIN 
  /DEPENDENT time89
  /METHOD=ENTER ed
  /METHOD=ENTER age female.
**********.
** Er sammenhengen mellom timelønn og alder lineær?.
* Curve Estimation med lineær og kvadratisk funksjon + tilpasningslinje lagt til..
TSET NEWVAR=NONE.
CURVEFIT
  /VARIABLES=time89 WITH age
  /CONSTANT
  /MODEL=LINEAR QUADRATIC 
  /PLOT FIT.
** Dette gir et spredningsdiagram med linjer for lineær og kvadratisk sammenheng.
** Dobbelklikk på spredningsdiagramme for å åpne Chart editor.
** Velg Elements og deretter Interpolation line. Dette gir flere valg  av tilpasningslinjer.
****************************************
* Modell 3 og 4.
**********
* Først lager vi variabler for alder kvadrert og for samspillet mellom kjønn og utdanning.
compute age2 = age*age.
compute edfem = ed*female.
desc age age2 edfem.
********* Modell 3.
REGRESSION
  /MISSING LISTWISE
  /STATISTICS COEFF OUTS R ANOVA CHANGE
  /CRITERIA=PIN(.05) POUT(.10)
  /NOORIGIN 
  /DEPENDENT time89
  /METHOD=ENTER ed age age2 female.
***************************
****** Samspill, subgruppeanalyse med forenklet modell.
*** Kvinner.
TEMPORARY.
SELECT IF female = 0.    
REGRESSION
  /MISSING LISTWISE
  /STATISTICS COEFF OUTS R ANOVA
  /CRITERIA=PIN(.05) POUT(.10)
  /NOORIGIN 
  /DEPENDENT time89
  /METHOD=ENTER ed.
**** Menn.
TEMPORARY.
SELECT IF female = 1.  
REGRESSION
  /MISSING LISTWISE
  /STATISTICS COEFF OUTS R ANOVA
  /CRITERIA=PIN(.05) POUT(.10)
  /NOORIGIN 
  /DEPENDENT time89
  /METHOD=ENTER ed.
*****************************************
* Modell 4 med samspill og diagnoseplott.
REGRESSION
  /MISSING LISTWISE
  /STATISTICS COEFF OUTS R ANOVA
  /CRITERIA=PIN(.05) POUT(.10)
  /NOORIGIN 
  /DEPENDENT time89
  /METHOD=ENTER ed age age2 female edfem
  /SCATTERPLOT=(*ZRESID ,*ZPRED)
  /RESIDUALS HISTOGRAM(ZRESID) NORMPROB(ZRESID).
****************************************.
* Regresjon med logaritmisk transformasjon av timelønn.
compute ltime89 = LN(time89).
desc time89 ltime89.
GRAPH   /HISTOGRAM(NORMAL)=ltime89.
* Regresjonsmodell med samspill som modell 4 med diagnoseplott.
REGRESSION
  /MISSING LISTWISE
  /STATISTICS COEFF OUTS R ANOVA
  /CRITERIA=PIN(.05) POUT(.10)
  /NOORIGIN 
  /DEPENDENT ltime89
  /METHOD=ENTER ed age age2 female edfem
  /SCATTERPLOT=(*ZRESID ,*ZPRED)
  /RESIDUALS HISTOGRAM(ZRESID) NORMPROB(ZRESID).
* Regresjonsmodell uten samspill som modell 3 med diagnoseplott.
REGRESSION
  /MISSING LISTWISE
  /STATISTICS COEFF OUTS R ANOVA
  /CRITERIA=PIN(.05) POUT(.10)
  /NOORIGIN 
  /DEPENDENT ltime89
  /METHOD=ENTER ed age age2 female
  /SCATTERPLOT=(*ZRESID ,*ZPRED)
  /RESIDUALS HISTOGRAM(ZRESID) NORMPROB(ZRESID).
*********************************************************.
* Regresjon med dummyvariabler er enklest med univariate som gir test for om R2 økes med klasse89.
*********.
UNIANOVA time89 BY klasse89 WITH ed age age2 female edfem
  /METHOD=SSTYPE(3)
  /INTERCEPT=INCLUDE
  /PRINT PARAMETER
  /CRITERIA=ALPHA(.05)
  /DESIGN=ed age age2 female edfem klasse89.
*** Ved bruk av regression må en første lage fire dummyvariabler.
recode klasse89 (1=1)(2,3,4,5=0)into kl1.
recode klasse89 (2=1)(1,3,4,5=0)into kl2.
recode klasse89 (3=1)(1,2,4,5=0)into kl3.
recode klasse89 (4=1)(1,2,3,5=0)into kl4.
fre klasse89 kl1 to kl4.
*** Regresjon med dummyvariabler i to blokker gir test av om R2 økes med klasse89.
REGRESSION
  /MISSING LISTWISE
  /STATISTICS COEFF OUTS R ANOVA CHANGE
  /CRITERIA=PIN(.05) POUT(.10)
  /NOORIGIN 
  /DEPENDENT time89
  /METHOD=ENTER ed age age2 female edfem
  /METHOD=ENTER kl1 to kl4.
*************************************************************.
* Kapittel 20 Logistisk regresjon..
***********.
* Datasett abu89.sav må være åpnet.
**  Modell 1..
LOGISTIC REGRESSION VARIABLES promot
  /METHOD=ENTER female 
  /CRITERIA=PIN(.05) POUT(.10) ITERATE(20) CUT(.5).
*** Merk at oddsratio (OR) er i siste kolonne merket Exp(B).
**  Modell 2..
LOGISTIC REGRESSION VARIABLES promot
  /METHOD=ENTER female ed fexp private
  /CRITERIA=PIN(.05) POUT(.10) ITERATE(20) CUT(.5).
*** Figur 20.3, ikke formattert som i Enhet og mangfold.
** Først beregne en predikert logit for ed=0 ved å multiplisere kontrollvariablene med koeffisientene.
compute pl0 = -1.374-0.219*0.4686+0.584*0.9451+0.202*0.6118.
EXECUTE.
*** predikert logit etter utdanning.
compute pl_utd = pl0+ed*0.102.
EXECUTE.
*** Predikert sannsynlighet.
compute pred_p = 1/(1+exp(-pl_utd)).
EXECUTE.
means pred_p by ed.
* Chart Builder.
* Merk at linjen har en knekk som skyldes at ingen har verdi ed=2.
GGRAPH
  /GRAPHDATASET NAME="graphdataset" VARIABLES=ed MEAN(pred_p)[name="MEAN_pred_p"] MISSING=LISTWISE 
    REPORTMISSING=NO
  /GRAPHSPEC SOURCE=INLINE.
BEGIN GPL
  SOURCE: s=userSource(id("graphdataset"))
  DATA: ed=col(source(s), name("ed"), unit.category())
  DATA: MEAN_pred_p=col(source(s), name("MEAN_pred_p"))
  GUIDE: axis(dim(1), label("År utdanning"))
  GUIDE: axis(dim(2), label("Mean pred_p"))
  GUIDE: text.title(label("Simple Line Mean of pred_p by År utdanning"))
  SCALE: linear(dim(2), include(0))
  ELEMENT: line(position(ed*MEAN_pred_p), missing.wings())
END GPL.
***********************.
* Modell 3.
LOGISTIC REGRESSION VARIABLES promot
  /METHOD=ENTER female ed fexp private edfem
  /CRITERIA=PIN(.05) POUT(.10) ITERATE(20) CUT(.5).
* Modell 4, krever en ny variabel.
compute fexp2 =fexp*fexp.
EXECUTE.
LOGISTIC REGRESSION VARIABLES promot
  /METHOD=ENTER female ed fexp fexp2 private
  /CRITERIA=PIN(.05) POUT(.10) ITERATE(20) CUT(.5).
**** Modell 4 i OLS.
REGRESSION
  /MISSING LISTWISE
  /STATISTICS COEFF OUTS R ANOVA
  /CRITERIA=PIN(.05) POUT(.10)
  /NOORIGIN 
  /DEPENDENT promote
  /METHOD=ENTER female ed fexp fexp2 private.
************************
* lrtest må gjøres manuelt slik som forklart i Enhet og mangfold.
***************
***************************************************.
* Kapittel 21
***********.
* Datasett wage89.sav må være åpnet.
************************
* Eksempel 1 flermnivåanalyse av timelønn
**********
*** Transformere wage og size, lager alder kvadrert og samspillsledd.
compute lnwage = ln(wage).
compute lnsize = ln(size).
compute age2 = age*age.
compute edsize = edyears*lnsize.
desc wage size lnwage lnsize age age2 edsize.
*
* Trinn 1 Nullmodellen,  utskrift s. 479).
mixed lnwage /fixed /random=intercept |subject(firmno)
  /method=ml 
  /print=solution testcov.
* Trinn 2 modell med stokastisk regresjonskonstant.
mixed lnwage with edyears age age2 female
  /fixed =edyears age age2 female /random=intercept 
  |subject(firmno) covtype(vc)
  /method=ml /print=solution testcov.
* Trinn3 modell der både regresjonskonstant og regresjonskoeffisient er stokastiske.
mixed lnwage with edyears age age2 female
  /fixed=edyears age age2 female /random=intercept edyears
  |subject(firmno) covtype(un) /method=ml
 /print=solution testcov.
 * Trinn 4 med lnsize og kryssnivåsamspill.
mixed lnwage with edyears age age2 female lnsize edsize
  /fixed=edyears age age2 female lnsize edsize /random=intercept edyears
  |subject(firmno) covtype(un) /method=ml
 /print=solution testcov.
*****************************************
*** Modellene i tabell 21.2.
**********
** Merk at overskriften på siste kolonne i tabellen s. 484-485 er feil "copeinc" skal være "edyears".
**Vanlig regresjon -  OLS. 
regression /dependent lnwage /methods=enter edyears age age2  female lnsize.
** OLS robuste standardfeil.
UNIANOVA lnwage WITH edyears age age2 female lnsize
  /METHOD=SSTYPE(3)
  /INTERCEPT=INCLUDE
  /CRITERIA=ALPHA(.05)  
  /ROBUST=HC3
  /DESIGN=edyears age age2 female lnsize.
** + samspill.
UNIANOVA lnwage WITH edyears age age2 female lnsize edsize
  /METHOD=SSTYPE(3)
  /INTERCEPT=INCLUDE
  /CRITERIA=ALPHA(.05)  
  /ROBUST=HC3
  /DESIGN=edyears age age2 female lnsize edsize.
** Fasteffektmodellen.
UNIANOVA lnwage BY firmno WITH edyears age age2 female
  /METHOD=SSTYPE(3)
  /INTERCEPT=INCLUDE
  /PRINT PARAMETER
  /CRITERIA=ALPHA(.05)
  /DESIGN=edyears age age2 female firmno.
******** Flernivåmodellene er spesifisert ovenfor ********.
*******************************************************.
* Eksempel 2 Flernivåanalyse av lykke.
*****************.
* Datasett Lykke.sav må være åpnet.
* Tabell 21.3 Beskrivende statistikk.
desc happy alder kvinne samboer utdann copeinc hdi2012 kulik2012.
*** Lage alder kvadrert og samspillsledd.
compute alder2 = alder*alder.
compute copehdi = copeinc*hdi2012.
EXECUTE.
* Trinn 1 nullmodellen . 
mixed happy /fixed  /random=intercept |subject(cntry)  /method=ml /print=solution testcov.
* Trinn 2 Utvikle modellen for nivå-1   (utskrift faste koeffisienter s. 488 ).
mixed happy with alder alder2 kvinne samboer utdann copeinc  
  /fixed  alder alder2 kvinne samboer utdann copeinc   /random=intercept 
  |subject(cntry)  /method=ml /print=solution testcov.
* Trinn 3 Utvikle den stokastiske delen av modellen  (utskrift stokastisk del s. 488).
mixed happy with alder alder2 kvinne samboer utdann copeinc 
  /fixed  alder alder2 kvinne samboer utdann copeinc  
  /random=intercept copeinc 
  |subject(cntry) covtype(un) /method=ml /print=solution testcov.
Trinn 4 legge til nivå-2 variabler og kryssnivåinteraksjon.
mixed happy with alder alder2 kvinne samboer utdann copeinc  hdi2012 copehdi
  /fixed  alder alder2 kvinne samboer utdann copeinc hdi2012 copehdi
  /random=intercept copeinc 
  |subject(cntry) covtype(un) /method=ml /print=solution testcov.
* samspillet er ikke statistisk signifikant og kuttes.
mixed happy with alder alder2 kvinne samboer utdann copeinc  hdi2012
  /fixed  alder alder2 kvinne samboer utdann copeinc hdi2012
  /random=intercept copeinc 
  |subject(cntry) covtype(un) /method=ml /print=solution testcov.
  ***********************************************.
 *  Tabell 21.4 Ulike modeller for lykke
* Vanlig regresjon -  OLS.
regression /dependent happy /methods=alder alder2 kvinne samboer utdann copeinc hdi2012.
*** OLSrobuste standardfeil.
UNIANOVA happy WITH alder alder2 kvinne samboer utdann copeinc hdi2012
  /METHOD=SSTYPE(3)
  /INTERCEPT=INCLUDE
  /CRITERIA=ALPHA(.05)  
  /ROBUST=HC3
  /DESIGN=alder alder2 kvinne samboer utdann copeinc hdi2012.
** + samspill.
UNIANOVA happy WITH alder alder2 kvinne samboer utdann copeinc hdi2012 copehdi
  /METHOD=SSTYPE(3)
  /INTERCEPT=INCLUDE
  /CRITERIA=ALPHA(.05)  
  /ROBUST=HC3
  /DESIGN=alder alder2 kvinne samboer utdann copeinc hdi2012 copehdi.
** Fasteffektmodellen.
UNIANOVA happy BY cntry WITH alder alder2 kvinne samboer utdann copeinc hdi2012
  /METHOD=SSTYPE(3)
  /INTERCEPT=INCLUDE
  /PRINT PARAMETER
  /CRITERIA=ALPHA(.05)
  /DESIGN=alder alder2 kvinne samboer utdann copeinc hdi2012 cntry.
*
******** Flernivåmodellene er spesifisert ovenfor ********.,
********************** SLUTT *********************************.






